/*
Copyright (c) 2024 Dusk
All rights reserved.

This code is proprietary to Dusk AI Inc.
The code may be used solely for accessing the Service provided by Dusk AI Inc. following the Dusk Terms of Service ("Terms") accessible at dusk.gg/eula. You may not use this code for any use or purpose other than as expressly permitted by the Terms.
Restrictions set forth in the Terms include, but is not limited to, that you may not copy, adapt, modify, prepare derivative works based upon, distribute, license, sell, transfer, publicly display, publicly perform, transmit, stream, broadcast, attempt to discover any source code, reverse engineer, decompile, dissemble, or otherwise exploit the code as a whole or any portion of the code.
*/
"use strict";require("compatto");var e=require("rune-msgpack"),t=require("base-64"),n=require("xstate");function o(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var o=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,o.get?o:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,Object.freeze(t)}var r,a=o(e),i=o(t);!function(e){e.GameToServer="G",e.ServerToGame="S"}(r||(r={}));var c=function(e){return e.charCodeAt(0)};function s(e){var t,n=function(e){return Uint8Array.from(e,c)}((t=e.slice("RUNE_MSG_V2;".length),i.decode(t)));return a.decode(n)}function u(e){var t,n=a.encode(e,{maxDepth:25});return"RUNE_MSG_V2;"+(t=function(e){for(var t=[],n=0,o=e.length;n<o;n++)t.push(String.fromCharCode(e[n]));return t.join("")}(n),i.encode(t))}var d=new(function(){function e(){this.lastDecodedValue="",this.lastDecodedMessage=void 0}return e.prototype.isClientMessage=function(e){if(!this.isRuneMsg(e))return!1;var t=this.decode(e);return t.runeGameEvent||t.runeGameCommand},e.prototype.decodeGameToClient=function(e){if(this.isRuneMsg(e))return this.decode(e).runeGameEvent},e.prototype.decodeClientToGame=function(e){if(this.isRuneMsg(e))return this.decode(e).runeGameCommand},e.prototype.decodeGameToServer=function(e){if(this.isRuneMsg(e))return this.decode(e).gameToServer},e.prototype.decodeServerToGame=function(e){if(this.isRuneMsg(e))return this.decode(e).serverToGame},e.prototype.isRuneMsg=function(e){return"string"==typeof e&&e.startsWith("RUNE_MSG_V2;")},e.prototype.decode=function(e){return e===this.lastDecodedValue||(this.lastDecodedValue=e,this.lastDecodedMessage=s(e)),this.lastDecodedMessage},e.prototype.encodeClientToGame=function(e){return u({runeGameCommand:e})},e.prototype.encodeGameToClient=function(e){return u({runeGameEvent:e})},e.prototype.encodeGameToServer=function(e){return u({gameToServer:e})},e.prototype.encodeServerToGame=function(e){return u({serverToGame:e})},e}()),T=function(){function e(){}return e.prototype.encodeClientToGame=function(e){return JSON.stringify(e)},e.prototype.encodeGameToClient=function(e){return JSON.stringify(e)},e.prototype.decodeClientToGame=function(e){if("string"==typeof e)try{return JSON.parse(e)}catch(e){return}},e.prototype.decodeGameToClient=function(e){if("string"==typeof e)try{return JSON.parse(e)}catch(e){return}},e}();exports.createGameClient=function(e){var t=e.network,o=e.onGameToClientPayload,r=e.onGameStateChanged,a=e.onReloadRequested,i=e.gameId,c=e.clientProtocolVersion,s=!1,u=function(e){return e>2?new T:d}(c),E=function(e){var t=e.onRequestStateSync,o=e.onRequestReload,r=n.createMachine({tsTypes:{},preserveActionOrder:!0,id:"CLIENT_STATE (v10)",initial:"NOT_READY",states:{NOT_READY:{initial:"LOADING",states:{LOADING:{on:{onInit:{target:"DISCONNECTED"},onConnected:{target:"WAITING_FOR_INIT"}}},WAITING_FOR_INIT:{on:{onInit:{target:"WAITING_FOR_STATE_SYNC"},onDisconnected:{target:"FAILED_TO_LOAD"}}},FAILED_TO_LOAD:{type:"final",entry:"REQUEST_RELOAD"},WAITING_FOR_STATE_SYNC:{entry:"REQUEST_STATE_SYNC",on:{onStateSync:{target:"WAITING_FOR_ON_CHANGE"}}},DISCONNECTED:{on:{onConnected:{target:"WAITING_FOR_STATE_SYNC"}}},ERR:{},WAITING_FOR_ON_CHANGE:{on:{onChange:{target:"#CLIENT_STATE (v10).READY"}}}}},READY:{initial:"PLAYING",states:{PLAYING:{on:{onGameOver:{target:"GAME_OVER"},onStateSync:{}}},GAME_OVER:{on:{onStateSync:{target:"PLAYING"}}}}}},on:{onError:{target:".NOT_READY.ERR"},onDisconnected:{target:"#CLIENT_STATE (v10).NOT_READY.DISCONNECTED"}},schema:{context:{},events:{}},context:{}},{actions:{REQUEST_STATE_SYNC:t,REQUEST_RELOAD:o}}),a=n.interpret(r);return a.start(),a}({onRequestStateSync:function(){t.sendMsgToGame(u.encodeClientToGame({type:"READY_TO_REQUEST_STATE_SYNC"}))},onRequestReload:function(){a()}});E.onTransition((function(e,n){if(e.changed){if(e.matches("NOT_READY.DISCONNECTED")&&t.sendMsgToGame(u.encodeClientToGame({type:"DISCONNECTED"})),e.matches("NOT_READY.ERR"))return r({state:"ERR"});if(e.matches("NOT_READY"))return r({state:"LOADING"});if(e.matches("READY.PLAYING"))return r({state:"PLAYING"});if(e.matches("READY.GAME_OVER")&&"onGameOver"===n.type)return r({state:"GAME_OVER",context:n.context});throw new Error("State machine is in unexpected state: ".concat(e.value))}}));var f={onServerMsg:function(e){s||E.state.matches("NOT_READY.LOADING")||E.state.matches("NOT_READY.WAITING_FOR_INIT")||E.state.matches("NOT_READY.DISCONNECTED")||t.sendMsgToGame(e)},onGameMsg:function(e){if(!s)if(function(e,t){return e>2?function(e){return"{"==e[0]}(t):d.isClientMessage(t)}(c,e)){var n=u.decodeGameToClient(e);if(n)if("ON_STATE_SYNC"!==n.type)n.gameId===i?("INIT"===n.type&&E.send("onInit"),"ON_CHANGE"!==n.type?("GAME_OVER"===n.type&&E.send({type:"onGameOver",context:n.context}),"ERR"===n.type&&E.send("onError"),o(n)):E.send("onChange")):"WINDOW_ERR"!==n.type&&"ERR"!==n.type&&"WARNING"!==n.type||o(n);else{if(n.gameId!==i)return;E.send("onStateSync")}}else t.sendMsgToServer(e)},onDisconnected:function(){s||E.send("onDisconnected")},onConnected:function(){s||E.send("onConnected")},sendMsgToGame:function(e){s||t.sendMsgToGame(u.encodeClientToGame(e))},stop:function(){s||(s=!0,E.stop())}};return r({state:"LOADING"}),f};
